
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>percona-toolkit对MySQL的复制和监控类操作教程_Mysql / iVAN</title>

    <meta name="description" content="percona-toolkit对MySQL的复制和监控类操作教程_Mysql 复制类工具 1.  pt-heartbeat功能介绍: 监控mysql复制延迟 用法介绍: pt-heartbeat [OPTION...] [DSN] --update|--monitor|--check|--stop 测量复制落后主mysql或者主PostgreSQL多少时间,你可以使用这个脚本去更新主或者监控复制,具体用法见后面的示例. 原理:pt-heartbeat通过真实的复制数据来确认mysql和postgresql复制延迟,这个避免了对复制机制的依赖,从而能得出准确的落后复制时间,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">percona-toolkit对MySQL的复制和监控类操作教程_Mysql</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>复制类工具<br />
1.  pt-heartbeat<br /></strong>功能介绍：<br />
监控mysql复制延迟<br />
用法介绍：<br />
pt-heartbeat [OPTION...] [DSN] --update|--monitor|--check|--stop<br />
测量复制落后主mysql或者主PostgreSQL多少时间，你可以使用这个脚本去更新主或者监控复制，具体用法见后面的示例.<br />
原理：pt-heartbeat通过真实的复制数据来确认mysql和postgresql复制延迟，这个避免了对复制机制的依赖，从而能得出准确的落后复制时间，包含两部分：第一部分在主上pt-heartbeat的--update线程会在指定的时间间隔更新一个时间戳，第二部分是pt-heartbeat的--monitor线程或者--check线程连接到从上检查复制的心跳记录（前面更新的时间戳），并和当前系统时间进行比较，得出时间的差异。<br />
你可以手工创建heartbeat表或者添加--create-table参数，推荐使用MEMORY引擎。表结构为：</p>
<pre>
CREATE TABLE heartbeat (
 ts       varchar(26) NOT NULL,
 server_id    int unsigned NOT NULL PRIMARY KEY,
 file       varchar(255) DEFAULT NULL,  -- SHOW MASTER STATUS
 position     bigint unsigned DEFAULT NULL, -- SHOW MASTER STATUS
 relay_master_log_file varchar(255) DEFAULT NULL,  -- SHOW SLAVE STATUS
 exec_master_log_pos bigint unsigned DEFAULT NULL -- SHOW SLAVE STATUS
);
</pre>
<p> <br />
使用示例：<br />
范例1：创建一个后台进程定期更新主上的test库的heartbeat表（）默认是1s，可以--interval指定，执行后会成一个heartbeat表，test库为我监控的同步库：</p>
<pre>
pt-heartbeat -D test --update --user=root --password=zhang@123 -h192.168.3.135 --create-table –daemonize
</pre>
<p>范例2：监控复制在slave上的落后程度（会一直监控）：</p>
<pre>
pt-heartbeat -D test --monitor --user=root --password=zhang@123 -h192.168.3.92
</pre>
<p>监控结果如下：</p>
<pre>
0.00s [ 0.00s, 0.00s, 0.00s ]
0.00s [ 0.00s, 0.00s, 0.00s ]
0.00s [ 0.00s, 0.00s, 0.00s ]
0.00s [ 0.00s, 0.00s, 0.00s ]
0.00s [ 0.00s, 0.00s, 0.00s ]
0.00s [ 0.00s, 0.00s, 0.00s ]
</pre>
<p>范例3：监控复制在slave上的落后程度（监控一次退出）：</p>
<pre>
pt-heartbeat -D test --check --user=root --password=zhang@123 -h192.168.3.92
</pre>
<p>范例4：监控PostgreSQL需要添加--dbi-driver Pg：</p>
<pre>
pt-heartbeat -D test --check --user=root --password=zhang@123 -h192.168.3.92 --dbi-driver Pg
</pre>
<p> <br /><strong>2. pt-slave-delay<br /></strong>功能介绍：<br />
设置从服务器落后于主服务器指定时间。<br />
用法介绍：<br />
pt-slave-delay [OPTION...] SLAVE-HOST [MASTER-HOST]<br />
原理：通过启动和停止复制sql线程来设置从落后于主指定时间。默认是基于从上relay日志的二进制日志的位置来判断，因此不需要连接到主服务器，如果IO进程不落后主服务器太多的话，这个检查方式工作很好，如果网络通畅的话，一般IO线程落后主通常都是毫秒级别。一般是通过--delay and --delay"+"--interval来控制。--interval是指定检查是否启动或者停止从上sql线程的频繁度，默认的是1分钟检查一次。<br />
使用示例：<br />
范例1：使从落后主1分钟，并每隔1分钟检测一次，运行10分钟</p>
<pre>
pt-slave-delay --user=root --password=zhang@123 --delay 1m --run-time 10m --host=192.168.3.92
</pre>
<p>如果不加--run-time参数会一直执行。<br />
范例2：使从落后主1分钟，并每隔15秒钟检测一次，运行10分钟</p>
<pre>
pt-slave-delay --user=root --password=zhang@123 --delay 1m --interval 15s --run-time 10m --host=192.168.3.92
</pre>
<p>运行结果如下：</p>
<pre>
2012-05-20T16:34:50 slave running 0 seconds behind
2012-05-20T16:34:50 STOP SLAVE until 2012-05-20T16:35:50 at master position mysql-bin.000032/4392054
2012-05-20T16:35:05 slave stopped at master position mysql-bin.000032/4397124
2012-05-20T16:35:20 slave stopped at master position mysql-bin.000032/4402194
2012-05-20T16:35:35 slave stopped at master position mysql-bin.000032/4407264
2012-05-20T16:35:50 no new binlog events
2012-05-20T16:36:05 START SLAVE until master 2012-05-20T16:35:05 mysql-bin.000032/4397124
</pre>
<p> <br /><strong>3. pt-slave-find<br /></strong>功能介绍：<br />
查找和打印mysql所有从服务器复制层级关系<br />
用法介绍：<br />
pt-slave-find [OPTION...] MASTER-HOST<br />
原理:连接mysql主服务器并查找其所有的从，然后打印出所有从服务器的层级关系。<br />
使用示例：<br />
范例1：查找主服务器为192.168.3.135的mysql有所有从的层级关系：</p>
<pre>
pt-slave-find --user=root --password=zhang@123 --host=192.168.3.135
</pre>
<p><strong>4. pt-slave-restart<br /></strong>功能介绍：<br />
监视mysql复制错误，并尝试重启mysql复制当复制停止的时候<br />
用法介绍：<br />
pt-slave-restart [OPTION...] [DSN]<br />
监视一个或者多个mysql复制错误，当从停止的时候尝试重新启动复制。你可以指定跳过的错误并运行从到指定的日志位置。<br />
使用示例：<br />
范例1：监视192.168.3.92的从，跳过1个错误</p>
<pre>
pt-slave-restart --user=root --password=zhang@123 --host=192.168.3.92 --skip-count=1
</pre>
<p>         范例2：监视192.168.3.92的从，跳过错误代码为1062的错误。</p>
<pre>
pt-slave-restart --user=root --password=zhang@123 --host=192.168.3.92 --error-numbers=1062
</pre>
<p><strong>5. pt-table-checksum<br /></strong>功能介绍：<br />
检查mysql复制一致性<br />
用法介绍：<br />
pt-table-checksum [OPTION...] [DSN]<br />
工作原理：pt-table-checksum在主上执行检查语句在线检查mysql复制的一致性，生成replace语句，然后通过复制传递到从，再通过update更新master_src的值。通过检测从上this_src和master_src的值从而判断复制是否一致。<br />
注意：使用的时候选择业务地峰的时候运行，因为运行的时候会造成表的部分记录锁定。使用--max-load来指定最大的负载情况，如果达到那个负载这个暂停运行。如果发现有不一致的数据，可以使用pt-table-sync工具来修复。<br />
注意：和1.0版本不同，新版本的pt-table-checksum只需要在master上执行即可。<br />
通过 –explain参数再结合二进制日志就可以看出脚本的工作原理，如我的test库有一个名字为zhang的表，我们通过抓取二进制日志来查看脚本的原理：</p>
<pre>
REPLACE INTO `test`.`checksums` (db, tbl, chunk, chunk_index, lower_boundary, upper_boundary, this_cnt, this_crc) SELECT 'test', 'zhang', '1', NULL, NULL, NULL, COUNT(*) AS cnt, COALESCE(LOWER(CONV(BIT_XOR(CAST(CRC32(CONCAT_WS('#', `id`, `name`, CONCAT(ISNULL(`name`)))) AS UNSIGNED)), 10, 16)), 0) AS crc FROM `test`.`zhang` /*checksum table*/;
UPDATE `test`.`checksums` SET chunk_time = '0.000563', master_crc = '31012777', master_cnt = '4' WHERE db = 'test' AND tbl = 'zhang' AND chunk = '1'
</pre>
<p>从这里可以很明显的看出原理了，前面已经说了，这里就不赘述了。<br />
使用示例：<br />
范例1：比较test数据库同步是否一致，结果显示所有的表。</p>
<pre>
pt-table-checksum --nocheck-replication-filters --databases=test --replicate=test.checksums --create-replicate-table --host=192.168.3.135 --port 3306 -uroot -pzhang@123
</pre>
<p>参数说明：第一次运行的时候需要添加--create-replicate-table参数，如果不加这个就需要手工运行添加表结构的SQL,表结构SQL如下：</p>
<pre>
CREATE TABLE checksums (
  db       char(64)   NOT NULL,
  tbl      char(64)   NOT NULL,
  chunk     int     NOT NULL,
  chunk_time   float      NULL,
  chunk_index  varchar(200)   NULL,
  lower_boundary text       NULL,
  upper_boundary text       NULL,
  this_crc    char(40)   NOT NULL,
  this_cnt    int     NOT NULL,
  master_crc   char(40)     NULL,
  master_cnt   int       NULL,
  ts       timestamp  NOT NULL,
  PRIMARY KEY (db, tbl, chunk),
  INDEX ts_db_tbl (ts, db, tbl)
) ENGINE=InnoDB;
</pre>
<p>之所以使用--nocheck-replication-filters参数是因为我的my.cnf配置了replicate-ignore-db和replicate-wild-do-table等参数。另外需要特别注意执行的checksums所在的数据库必须是同步的数据库。我刚开始使用的时候摸索的很久，官网也没有范例。呵呵！<br />
结果如下：</p>
<pre>
TS     ERRORS DIFFS ROWS CHUNKS SKIPPED TIME TABLE
05-23T16:19:29 0  1    2  1 0 0.006 test.aaa
05-23T16:19:29 0  0    1  1 0 0.017 test.bbb
05-23T16:19:29 0  0    0  1 0 0.007 test.category_part
05-23T16:19:31 0  0  233617  6 0 1.887 test.collect_data
05-23T16:19:34 0  0  250346  5 0 2.709 test.effective_user
05-23T16:19:34 0  1    1  1 0 0.008 test.heartbeat
05-23T16:19:39 0  0 1000000 11 0 5.353 test.oss_pvinfo2
</pre>
<p>从结果中，我们可以看到test.aaa和test.heartbeat表的DIFFS不为0，那么就是这两个表不同步了。<br />
 <br />
范例2：比较test数据库同步是否一致，结果只显示数据不一致的表（添加--replicate-check-only参数即可,这个值查看checksums数据不会重新对表进行比较，因此需要先运行上面的比较语句之后再运行这个语句，否则显示不了最新的变化。）。</p>
<pre>
pt-table-checksum --nocheck-replication-filters --databases=test --replicate=test.checksums --replicate-check-only --lock-wait-timeout=120 --host=192.168.3.135 --port 3306 --user=root --password=zhang@123
</pre>
<p>结果如下：</p>
<pre>
Differences on localhost.localdomain
TABLE CHUNK CNT_DIFF CRC_DIFF CHUNK_INDEX LOWER_BOUNDARY UPPER_BOUNDARY
test.aaa 1 1 1
test.heartbeat 1 0 1
</pre>
<p>从结果可以看出，只显示了两个不同步的表。</p>
<p><strong>6. pt-table-sync<br /></strong>功能介绍：<br />
高效同步mysql表的数据<br />
用法介绍：<br />
pt-table-sync [OPTION...] DSN [DSN...]<br />
原理：总是在主上执行数据的更改，再同步到从上，不会直接更改成从的数据，在主上执行更改是基于主上现在的数据，不会更改主上的数据。注意使用之前先备份你的数据，避免造成数据的丢失.执行execute之前最好先换成--print或--dry-run查看一下会变更哪些数据。<br />
使用示例：<br />
范例1：同步3.135的test库的aaa表到192.168.3.92，在执行之前可以用--execute参数换成--print来查看会变更什么东西，后面那个主机必须是master，否则会报错推出。</p>
<pre>
pt-table-sync --execute --user=root --password=zhang@123 h=192.168.3.135,D=test,t=aaa h=192.168.3.92
</pre>
<p>范例2：将主的test数据库同步到192.168.3.92，使从上具有一样的数据。</p>
<pre>
pt-table-sync --execute --sync-to-master --user=root --password=zhang@123 h=192.168.3.92 --database test
</pre>
<p>范例3：只同步指定的表</p>
<pre>
pt-table-sync --execute --sync-to-master --user=root --password=zhang@123 h=192.168.3.92,D=test,t=aaa
</pre>
<p>范例4：根据pt-table-checksum的结果进行数据同步</p>
<pre>
pt-table-sync --execute --replicate test.checksums --user=root --password=zhang@123 h=192.168.3.135
</pre>
<p>范例5：根据pt-table-checksum使从的数据和主的数据一致</p>
<pre>
pt-table-sync --execute --replicate test.checksums --user=root --password=zhang@123 --sync-to-master h=192.168.3.92,D=test,t=aaa
</pre>
<p><strong>监控类工具<br />
1. pt-deadlock-logger<br /></strong>功能介绍：<br />
提取和记录mysql死锁的相关信息<br />
用法介绍：<br />
pt-deadlock-logger [OPTION...] SOURCE_DSN<br />
收集和保存mysql上最近的死锁信息，可以直接打印死锁信息和存储死锁信息到数据库中，死锁信息包括发生死锁的服务器、最近发生死锁的时间、死锁线程id、死锁的事务id、发生死锁时事务执行了多长时间等等非常多的信息。详情见下面的示例。<br />
使用示例：<br />
范例1：打印本地mysql的死锁信息</p>
<pre>
pt-deadlock-logger --user=root --password=zhang@123 h=localhost –print
</pre>
<p>范例2：将本地的mysql死锁信息记录到数据库的表中，也打印出来</p>
<pre>
pt-deadlock-logger --user=root --password=zhang@123 h=localhost --print D=test,t=deadlocks
</pre>
<p><strong>2. pt-fk-error-logger<br /></strong>功能介绍：<br />
提取和记录mysql外键错误信息<br />
用法介绍：<br />
pt-fk-error-logger [OPTION...] SOURCE_DSN<br />
通过SHOW INNODB STATUS提取和保存mysql数据库最近发生的外键错误信息。可以通过参数控制直接打印错误信息或者将错误信息存储到数据库的表中。<br />
使用示例：<br />
我在服务器上运行的时候一直报如下错误：</p>
<pre>
Use of uninitialized value in concatenation (.) or string at /usr/bin/pt-fk-error-logger line 2045
</pre>
<p>我怀疑是这个程序有问题，回头换一个版本试一下或者调试一下那个程序。<br />
 <br /><strong>3. pt-mext<br /></strong>功能介绍：<br />
并行查看SHOW GLOBAL STATUS的多个样本的信息。<br />
用法介绍：<br />
pt-mext [OPTIONS] -- COMMAND<br />
原理：pt-mext执行你指定的COMMAND，并每次读取一行结果，把空行分割的内容保存到一个一个的临时文件中，最后结合这些临时文件并行查看结果。<br />
使用示例：<br />
范例1：每隔10s执行一次SHOW GLOBAL STATUS，并将结果合并到一起查看</p>
<pre>
pt-mext -- mysqladmin ext -uroot -pzhang@123 -i10 -c3
</pre>
<p> <br /><strong>4. pt-query-digest<br /></strong>功能介绍：<br />
分析查询执行日志，并产生一个查询报告，为MySQL、PostgreSQL、 memcached过滤、重放或者转换语句。<br />
用法介绍：<br />
pt-query-digest [OPTION...] [FILE]<br />
解析和分析mysql日志文件<br />
使用示例：<br />
范例1：分析本地的慢查询文件</p>
<pre>
pt-query-digest --user=root --password=zhang@123 /data/dbdata/localhost-slow.log
</pre>
<p>范例2：重新回顾满查询日志，并将结果保存到query_review中，注意query_review表的表结构必须先建好，表结构如下：</p>
<pre>
CREATE TABLE query_review (
  checksum   BIGINT UNSIGNED NOT NULL PRIMARY KEY,
  fingerprint TEXT NOT NULL,
  sample    TEXT NOT NULL,
  first_seen  DATETIME,
  last_seen  DATETIME,
  reviewed_by VARCHAR(20),
  reviewed_on DATETIME,
  comments   TEXT
);
</pre>
<p>命令如下：</p>
<pre>
pt-query-digest --user=root --password=zhang@123 --review h=localhost,D=test,t=query_review /data/dbdata/localhost-slow.log
</pre>
<p><strong>5. pt-trend<br /></strong>功能介绍：<br />
居于一组时间序列的数据点做统计。<br />
用法介绍：<br />
pt-trend [OPTION...] [FILE ...]<br />
读取一个慢查询日志，并输出统计信息。也可以指定多个文件。如果不指定文件的话直接从标准输入中读取信息。<br />
使用示例：<br />
范例1：读取本地慢查询日志并输出统计信息</p>
<pre>
pt-trend /data/dbdata/localhost-slow.log</pre>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索mysql<br />
                    ，                教程<br />
                    ，                MySQL教程<br />
                                    percona-toolkit<br />
                                    percona mysql 监控、percona toolkit、percona toolkit 安装、percona toolkit 使用、percona toolkit下载，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-26 20:25:30</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/mysql/" title="mysql">mysql</a>, <a href="https://www.iamivan.net/tag/%e6%95%99%e7%a8%8b/" title="教程">教程</a>, <a href="https://www.iamivan.net/tag/mysql%e6%95%99%e7%a8%8b/" title="MySQL教程">MySQL教程</a>, <a href="https://www.iamivan.net/tag/percona-toolkit/" title="percona-toolkit">percona-toolkit</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>percona-toolkit对MySQL的复制和监控类操作教程_Mysql的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAkVknz.html" rel="bookmark">MySQL使用profile查询性能的操作教程&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MYSQL的profiling功能要在Mysql版本5.0.37以上才能使用. 查看profile是否开启 mysql&gt; show variables like '%profil%'; +------------------------+-------+ | Variable_name | Value | +------------------------+-------+ | profiling | OFF | --开启SQL语句剖析功能 | profiling_history_size |			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxElRQp.html" rel="bookmark">MySQL中修改库名的操作教程&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL在5.1引入了一个rename database操作,但在MySQL5.1.23后又不支持这个命令.可以说是一个实验性的功能,没有在生产中支持过(mysql-5.1 release在mysql-5.1.30),那么生产中我们有时为了追求完美需要改一下库名.怎么操作呢? 这里提供一个变通的方法. 1. 创建出新库名: mysql&gt;create database db_v2; mysql&gt;create database db_v2; 2.生成rename语句,从olddb里迁移,我这里o			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmlm2z.html" rel="bookmark">Linux下将数据库从MySQL迁移到MariaDB的基础操作教程&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自从2012年来,维基百科已经开始从MySQL迁移到MariaDB的过程,是维基媒体数据库架构变革的一个重大里程碑,将英文和德文版的维基百科数据库Wikidata移植到了MariaDB 5.5版本上. 在过去几年中,维基百科一直使用 Facebook 的 MySQL 5.1 衍生版本 作为我们的产品数据库,构建版本号是r3753.我们很高兴该产品的性能表现,Facebook 有着全世界最棒的数据库工程师,他们为 MySQL 生态系统带去了很多改进. 现在 MariaDB 的优化器的增强.Perc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAkPOKz.html" rel="bookmark">使用mysqldump对MySQL的数据进行备份的操作教程&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL 自身的 mysqldump 工具支持单线程工作, 依次一个个导出多个表,没有一个并行的机 ,这就使得它无法迅速的备份数据. mydumper 作为一个实用工具,能够良好支持多线程工作, 可以并行的多线程的从表中读入数据并同时写到不同的文件里 ,这使得它在处理速度方面快于传统的 mysqldump .其特征之一是在处理过程中需要对列表加以锁定,因此如果我们需要在工作时段执行备份工作,那么会引起 DML 阻塞.但一般现在的 MySQL 都有主从,备份也大部分在从上进行,所以锁的问题可以不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBXZaJp.html" rel="bookmark">PureFTP借助MySQL实现用户身份验证的操作教程&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				pureftp集成mysql身份验证是将ftp用户信息保存到mysql数据库中,这样可以对大量的ftp服务器做集中管理,对用户帐号的维护只要通过mysql的操作就可以完成. 一.下载pureftp源代码,并确定mysql已经安装好 tar zxvf pure-ftpd-1.0.20.tar.gz cd pure-ftpd-1.0.20 ./configure --prefix=/usr/local/pureftpd \ --with-cookie \ --with-throttling \ --			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z768Krp.html" rel="bookmark">使用Percona Toolkit解决Mysql主从不同步问题【备忘】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于各种原因,mysql主从架构经常会出现数据不一致的情况出现,大致归结为如下几类 1:备库写数据 2:执行non-deterministic query 3:回滚掺杂事务表和非事务表的事务 4:binlog或者relay log数据损坏 数据不同步给应用带来的危害是致命的,当出现主从数据不一致的情况,常见的应对方法是先把从库下线,然后找个半夜三更的时间把应用停掉,重新执行同步,如果数据库的体积十分庞大,那工作量可想而知,会让人崩溃.本文介绍使用percona-toolkit工具对mysql主从			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRdvAaz.html" rel="bookmark">MySQL中复制数据表中的数据到新表中的操作教程&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL是不支持SELECT - INTO语法的,使用INSERT INTO - SELECT替代相同用法,下面我们我们这里简答分一下新表存在和不存在两种情况,具体使用不同的语句.1.新表不存在复制表结构即数据到新表 create table new_table select * from old_talbe; 这种方法会将old_table中所有的内容都拷贝过来,用这种方法需要注意,new_table中没有了old_table中的primary key,Extra,auto_incremen			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwnRVOp.html" rel="bookmark">MySQL快速复制数据库数据表的方法&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				某些时候,例如为了搭建一个测试环境,或者克隆一个网站,需要复制一个已存在的mysql数据库.使用以下方法,可以非常简单地实现. 假设已经存在的数据库名字叫db1,想要复制一份,命名为newdb.步骤如下: 1. 首先创建新的数据库newdb #mysql -u root -ppassword mysql&gt;CREATE DATABASE `newdb` DEFAULT CHARACTER SET UTF8 COLLATE UTF8_GENERAL_CI; 2. 使用mysqldump及mysql的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mydo2vb.html" rel="bookmark">mysql 5&period;7 docker 主从复制架构搭建教程&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				分享mysql 5.7 docker 主从复制架构搭建教程,供大家参考,具体内容如下 环境版本: MySQL :  5.7.13 Docker : 1.11.2 CentOS : 7.1  1.先在两个物理机上分别安装两个MySQL.命令如下  复制代码 代码如下: docker pull mysql:5.7.13  docker run --name anuo-mysql -p 3306:3306 -e MYSQL_ROOT_PASSWORD=qaz.00JK -d mysql:5.7.13 			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvrY8M.html" rel="bookmark" class="title">从一般管理原则看微软的重组 &period;</a>
					<div>
						事先声明:想对微软这样一个庞大的公司做出周到客观的评价其实很难,我只评价我看到的,也只保证逻辑通畅.   微软近来重组了,有人看好,有人看衰,我这里用一般管理原则看一下这次重组,目标不是说微软,而是说 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVyelp.html" rel="bookmark" class="title">网页鼠标右键被禁用破解又一法</a>
					<div>
						禁用|破解|鼠标|网页|右键 遇到网页上有精美图片或者精彩文字想保存时,通常大家都是选中目标后按鼠标右键,在弹出菜单中选择&quot;图片另存为&quot;或&quot;复制&quot;来达到我们的目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZlJYM.html" rel="bookmark" class="title">兼顾搜索：论坛优化如何应付那些&OpenCurlyDoubleQuote;垃圾&rdquo;信息</a>
					<div>
						站长为论坛做优化,无非是最费力的,一方面在用户体验上要做的呱呱叫响,另一方面搜索引擎的优化更是要面面俱到.否则介于论坛的特殊性,两者即使缺一,那么也将注定了论坛发展的举步维艰.论坛的发展,什么是阻碍它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7Y7XM.html" rel="bookmark" class="title">a标签伪类的作用及书写顺序是什么</a>
					<div>
						a标签的伪类只不过是又结合了不同的动作顺序,动作的触发顺序决定了伪类的顺序必须按lvha来写,接下来为大家详细介绍下,感兴趣的朋友不妨参考下 a标签伪类的作用: &quot;:link&quot;:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGVo5p.html" rel="bookmark" class="title">Win8&period;1安装教程</a>
					<div>
						  Win8系统首个正式升级版Win8.1已经放出了,大家可以去微软官网或者百度搜索下载.升级版的Win8.1增加了不少新特性,最大的亮点莫过于,开始菜单又回来了,并且内置了最新的IE11浏览器.对于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7PkOM.html" rel="bookmark" class="title">千千静听中怎么对歌词进行编辑调整和上传</a>
					<div>
						怎样使用千千静听对歌词进行编辑调整和上传: 1.在播放列表中选中您想要编辑歌词的曲目 2.在千千歌词秀显示窗口单击鼠标右键,在菜单中选择&quot;编辑歌词&quot;,进入歌词编辑模式. 如下图所示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8yOGb.html" rel="bookmark" class="title">Windows版微信体验如何</a>
					<div>
						  提到电脑版微信,大家肯定首先想到网页登陆微信,不过在微信推出Mac客户端后,现在也正式推出了Windows版客户端,没错,不是登陆网页,是实实在在的软件. 在跨平台的进程中,微信一直在做努力,从A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Ze2Vb.html" rel="bookmark" class="title">通过键盘也可以开机</a>
					<div>
						一般我们是通过按一下电脑的电源键开启电脑,但是你绝对没想到通过电脑键盘也可以实现开机.相信通过键盘开机的好处你也清楚,至少不用弯腰.哈哈.不管怎么样先了解下如何实现键盘开机 吧. 1 找到主板上的键盘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5onknb.html" rel="bookmark" class="title">2015年国内WiFi行业大事盘点</a>
					<div>
						2015年WiFi已经成为网民最主要的无线上网方式.在这一年里,关于WiFi的报道一直在猛刷存在感,也让我们回头看看2015年国内WiFi行业有哪些最值得关注的大事. 1.总理敦促网络提速降费 移动W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLakLvz.html" rel="bookmark" class="title">MVC&plus;EasyUI&plus;三层架构简单权限管理系统&lowbar;实用技巧</a>
					<div>
						闲来无事把以前做的一个项目整理了一下,今天拿出来跟大家分享,交流和探讨.希望大家多多指正. 一.项目架构图 其中Entity为模型实体层类库:DAL为数据访问层类库,主要负责数据库操作:BLL为业务逻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My34gdz.html" rel="bookmark" class="title">Android学习之使用SharedPreferences存储应用程序数据&lowbar;Android</a>
					<div>
						本文介绍了SharedPreferences保存应用程序数据的具体步骤,供大家参考,具体内容如下 1.SharedPreferences的简单介绍应用程序在运行的时候,可能会随着用户的使用而保持该用户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm5V0z.html" rel="bookmark" class="title">Linux内核编译与启动流程</a>
					<div>
						(额-觉得Linux编译链接过程和启动过程还是有那么点作用的哈,要理清楚细节非常多-趟了不少源码-记此备忘) 编译流程 1.编译除arch/x86/boot目录外的其他目录,生成各模块的built_i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze61Dwb.html" rel="bookmark" class="title">nginx上传模块&mdash;nginx upload module</a>
					<div>
						nginx上传模块 一. nginx upload module原理 官方文档: http://www.grid.net.ru/nginx/upload.en.html Nginx upload mo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm7q1b.html" rel="bookmark" class="title">Android系统shell中的clear命令实现</a>
					<div>
						之前一直不太清楚,当我们在shell命令行输入很多命令,会在屏幕上输出一些信息,为什么一执行clear这个命令以后,所有的信息就没了呢? 现在终于搞明白了,找到了clear命令的源代码clear.c  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXngyz.html" rel="bookmark" class="title">《Java 7程序设计入门经典》一3&period;14　像使用goto语句一样使用break语句</a>
					<div>
						3.14 像使用goto语句一样使用break语句 除了用于switch语句和循环外,break语句也可以用提供像goto语句一样的用法.由于goto语句是一种改变程序流的非结构化方法,因此Java并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWVYEz.html" rel="bookmark" class="title">原生js制作简单的数字键盘&lowbar;javascript技巧</a>
					<div>
						一.起因 最近支付的同事说,数字键盘有些问题:在移动设备上有时候比较难出现点(.) 和数字在一起的格局:因此,考虑到这种情况,就建议手写个模拟键盘了.花了一晚上的时间,写了个简单的键盘,基本能用.考虑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60GkWz.html" rel="bookmark" class="title">使用SKIP-GRANT-TABLES 解决 MYSQL ROOT密码丢失（转）</a>
					<div>
						B.5.3.2 How to Reset the Root Password If you have never assigned a root password for MySQL, the ser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7VkRz.html" rel="bookmark" class="title">图片上传</a>
					<div>
						protected void Upload()         {             //判断是否选择文件             if (FileUpload1.HasFile)        ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBLKgM.html" rel="bookmark" class="title">Raghuraman认为软件开发是一种艺术，而不是一门科学</a>
					<div>
						你可以学习软件开发的各种技术,不过还需要对编码有着充分的热情.如果你是这样的人,那么就可以成为&quot;伟大的开发者&quot;.Raghuraman列出了优秀的开发人员应该具有的态度: 态度1:缺 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0V25p.html" rel="bookmark" class="title">什么是md5盐值</a>
					<div>
						简单说就是为了使相同的密码拥有不同的hash值的一种手段 就是盐化 MD5自身是不可逆的 但是目前网路上有很多数据库支持反查询 如果用户密码数据库不小心被泄露 黑客就可以通过反查询方式获得用户密码 或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg9Y9M.html" rel="bookmark" class="title">intellij idea-Idea启动tomcat发布项目失败</a>
					<div>
						问题描述 Idea启动tomcat发布项目失败 &quot;D:Program Filesapache-tomcat-7.0.0incatalina.bat&quot; run [2015-10-16 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkyoKM.html" rel="bookmark" class="title">iOS毛玻璃效果的实现及图片模糊效果的三种方法&lowbar;IOS</a>
					<div>
						App设计时往往会用到一些模糊效果或者毛玻璃效果,iOS目前已提供一些模糊API可以让我们方便是使用. 话说苹果在iOS7.0之后,很多系统界面都使用了毛玻璃效果,增加了界面的美观性,比如下图的通知中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2NWVM.html" rel="bookmark" class="title">jQuery和hwSlider实现内容响应式可触控滑动切换效果附源码下载（二）&lowbar;jquery</a>
					<div>
						今天我们继续内容滑动切换效果的第二部分讲解.如今我们的web开发都要适应移动设备,就是说我们的web页面要在移动设备如手机端也能正常访问,所以我将第一部分的基本切换效果做了加强,增加了响应式和触控滑动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ15aOb.html" rel="bookmark" class="title">怎么利用支付宝钱包找回支付密码</a>
					<div>
						支持支付宝钱包7.6以上(含7.6)版本    前提条件:个人和公司账户都支持,账户已经绑定手机号码.   通过支付宝钱包找回支付密码共有以下4种方式:支付宝系统根据各账户的情况进行判断,各账户找回的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWQEkz.html" rel="bookmark" class="title">RUBY 新手教程 跟我一起学ruby&lowbar;ruby专题</a>
					<div>
						跟我一起学ruby By Tiger 注:本教程转载自在游戏先行者论坛,版权属于作者Tiger. 第一篇 第二篇 第一篇 自序 从今天起我就要开始学Ruby了.怎么样,没见吧?一个新人写教程.就凭我坚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW78weM.html" rel="bookmark" class="title">怎样同时使用upload上传组件和replace</a>
					<div>
						问题描述 在上传附件的同时去掉附件标题中的空格 解决方案 解决方案二:附件标题是什么意思?文件名吗?解决方案三:这个是upoad控件DimUpload,path,tempCls'=========== ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0qVWM.html" rel="bookmark" class="title">好莱坞艳照网上售卖：用比特币交易&comma;2145元可成交</a>
					<div>
						好莱坞艳照网上售卖:用比特币交易,2145元可成交台湾媒体报道,苹果公司iCloud伺服器之前被骇客入侵,造成许多好莱坞女星和名人裸照外洩,并演变成震撼&quot;性&quot;丑闻.迄今 曝光的裸照 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YKynp.html" rel="bookmark" class="title">引领4G 至美一拍，OPPO 千万豪礼等你拿</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 3721.html&quot;&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Yw0Wp.html" rel="bookmark" class="title">携程旅行网推出&OpenCurlyDoubleQuote;逸品游&rdquo;主题</a>
					<div>
						近日,国内最大的在线旅游服务商携程旅行网推出&quot;逸品游&quot;主题.独家发布10大国内线路,把高端旅游开发热延伸到了国内游市场. 据悉,携程今年大规模升级推出&quot;逸品游&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YoQJp.html" rel="bookmark" class="title">JRainbow 0&period;3版本发布</a>
					<div>
						简单介绍       JRainbow是一款基于Spring+Hibernate+Struts2+Extjs4的企业级开发的Eclipse开源插件.主要用于快速开发,针对都是Java开发人员,只是为程 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
